﻿; appinfo main file
; by felix caffier
; www.trisymphony.com
; 2015-01-24

IncludeFile "../applib.pb"

; init applib
initApplib()
setAppPathAndMode(APPLIB_PARAMS(0))
readAppXML()
setDefaultAppIcon()

; read text files - in order
readme.s = getTextfile("README")
eula.s = getTextfile("EULA")
license.s = getTextfile("LICENSE")
credits.s = getTextfile("CREDITS")

; load basic form
XIncludeFile "scaleform.pbf"
; resize window to desktop proportions
ExamineDesktops()
Openwinmain(0, 0, 900, DesktopHeight(0) - 300)
ResizeGadgetswinmain()

; remove empty tabs - in reverse order
If credits = ""
  RemoveGadgetItem(#infotabs, 3)
Else
  SetGadgetText(#ed_credits, credits)
EndIf
If license = ""
  RemoveGadgetItem(#infotabs, 2)
Else
  SetGadgetText(#ed_license, license)
EndIf
If eula = ""
  RemoveGadgetItem(#infotabs, 1)
Else
  SetGadgetText(#ed_eula, eula)
EndIf
If readme = ""
  RemoveGadgetItem(#infotabs, 0)
Else
  SetGadgetText(#ed_readme, readme)
EndIf

; fill buttons
If APPLIB_XMLEMAIL = ""
  DisableGadget(#b_mail, 1)
EndIf
If APPLIB_XMLWEBSITE = ""
  DisableGadget(#b_website, 1)
EndIf

; fill info text
infotext.s = APPLIB_XMLNAME
If APPLIB_XMLAUTHOR <> ""
  infotext + LANG_BY + APPLIB_XMLAUTHOR
EndIf
If APPLIB_XMLVERSION <> ""
  infotext + LANG_VERSION + APPLIB_XMLVERSION
EndIf
If APPLIB_XMLBUILD <> ""
  infotext + LANG_BUILD + APPLIB_XMLBUILD
EndIf

If APPLIB_XMLDATE <> ""
  infotext + " (" + APPLIB_XMLDATE + ")"
EndIf

If APPLIB_XMLDESCRIPTION <> ""
  infotext + Chr(13) + Chr(13) + APPLIB_XMLDESCRIPTION
EndIf

SetGadgetText(#l_info, infotext)

; event loop
Repeat
  Event = WaitWindowEvent()
    
  Select EventWindow()
    Case #winmain
      winmain_Events(Event)
      
  EndSelect
  
  
  Select EventGadget()
      ;Case
  EndSelect
      
Until Event = #PB_Event_CloseWindow

End
; IDE Options = PureBasic 5.24 LTS (Linux - x64)
; CursorPosition = 93
; EnableUnicode
; EnableThread
; EnableXP
; Executable = ../BUILD-x86_64/appinfo