﻿; appopen main file
; by felix caffier
; www.trisymphony.com
; 2015-02-20

OpenConsole()
IncludeFile "../applib.pb"

; init applib
initApplib()
setAppPathAndMode(APPLIB_PARAMS(0))
readAppXML()
setDefaultAppIcon()

; get local library folder (if any)
ldlib.s = APPLIB_CLEANPATH + "/lib-" + APPLIB_ARCH
If FileSize(ldlib) <> -2 ; folder not found - try generic folder
  ldlib = APPLIB_CLEANPATH + "/lib"
  If FileSize(ldlib) = -2 ; generic folder found
    SetEnvironmentVariable("LD_LIBRARY_PATH", ldlib)
  EndIf
Else ; arch-sepcific folder exists, add it to LD_LIBRARY_PATH
  SetEnvironmentVariable("LD_LIBRARY_PATH", ldlib)
EndIf


; get launch script
launchfile.s = APPLIB_CLEANPATH + "/launch-" + APPLIB_ARCH + ".sh"
If FileSize(launchfile) < 1 Or APPLIB_ARCH = "" ; no launch script found for this architecture, try generic script
  launchfile = APPLIB_CLEANPATH + "/launch.sh"
EndIf
If FileSize(launchfile) < 1 ; no generic launch script found either, abort
  MessageRequester(LANG_ERROR+" "+APPLIB_XMLNAME, LANG_LAUNCHSCRIPT)
  End
EndIf

; launch script found, now append parameters
paramlist.s = ""
asize = ArraySize(APPLIB_PARAMS())
If asize > 1
  For n=1 To asize-1
    paramlist + APPLIB_PARAMS(n) + " "
  Next
  Trim(paramlist)
EndIf

; gui app or console app?
If APPLIB_APPMODE = "apx"
  launched = RunProgram(launchfile, paramlist, APPLIB_CLEANPATH, #PB_Program_Open)
Else
  launched = RunProgram("st", "-e " + launchfile + " " + paramlist, APPLIB_CLEANPATH, #PB_Program_Open)
  ; system_()
EndIf

; has launched - or not
If launched
  WaitProgram(launched)
Else
  MessageRequester(LANG_ERROR+" "+APPLIB_XMLNAME, LANG_LAUNCHERROR)
  End
EndIf

exitcode = ProgramExitCode(launched)
PrintN(APPLIB_XMLNAME+": "+Str(exitcode))

; crash reporter
If exitcode <> 0 And APPLIB_XMLEMAIL <> ""
  res = MessageRequester(LANG_TERM, APPLIB_XMLNAME + LANG_TERMTEXT, #PB_MessageRequester_YesNo)
  If res = #PB_MessageRequester_No
    ; TODO - crash reporter app is a placeholder
    RunProgram("appcrashreporter", "badprogram", "/tmp", #PB_Program_Wait)
  EndIf
EndIf

End
; IDE Options = PureBasic 5.24 LTS (Linux - x64)
; ExecutableFormat = Console
; CursorPosition = 70
; FirstLine = 27
; EnableUnicode
; EnableThread
; EnableXP
; Executable = ../BUILD-x86_64/appopen